@echo off
rem ======================================================================
::
::  DEFRAG ALL DRIVES
::
::  This batchfile starts defrag for several drives.
::  In the line "set drives=" put your own driveletters.
::
rem ----------------------------------------------------------------------
::  2005-01-15  v1.0  created
::  2005-03-13  v1.1  - call %0 %%d replaced with call :defragdrive %%d
::                    - added starting and finishing time
::  Axel Hahn - support@axel-hahn.de
rem ======================================================================


rem ----------------------------------------------------------------------
::  CONFIG: set all driveletters of your system here
rem ----------------------------------------------------------------------
    set sDrives=C D E F G H I

    :: set sDefragOptions=-fv
    set sDefragOptions=
    set LINE=-------------------------------------------------------------------------------



rem ----------------------------------------------------------------------
::  DO NOT CHANGE BELOW THIS LINE
rem ----------------------------------------------------------------------

    :: 2005-03-13: removed 2 lines
    :: if "%1"=="" goto defragall
    :: goto defragdrive

    rem ------------------------------------------------------------------
    ::  MAIN: start defragmentation for all drives
    rem ------------------------------------------------------------------
    :defragall
    echo %LINE%
    echo.
    echo xxxxx DEFRAG ALL DRIVES - v1.1 xxxxx
    echo.
    :: 2005-03-13: changed 1 line
    :: for %%d in (%sDrives%) do call %0 %%d
    for %%d in (%sDrives%) do call :defragdrive %%d

    echo %LINE%
    pause
    goto end


    rem ------------------------------------------------------------------
    ::  defrag a single drive
    rem ------------------------------------------------------------------
    :defragdrive
    echo %LINE%
    cd /d %WINDIR%\system32
    echo.
    echo defragmentation of drive %1:
    echo.
    echo starting time:
    date /t
    time /t
    @echo on
    defrag %sDefragOptions% %1:
    @echo off
    echo.
    echo finishing time:
    time /t
    echo.
    goto end

    :end

rem ----------------------------------------------------------------------
::  EOF
rem ----------------------------------------------------------------------